signature FILEUTILS = sig

(* Miscellaneous file utilities *)

(* If the named file does not include a specific path, try to open it 
   in either the current directory or a subdirectory called "examples".  
   If it appears in neither place, try adding the suffix search-suffix
   (defined in make.use) to the name.  If any of these succeed, return
   the actual file name and an instream. *)
val search_for_file: string -> (instream * string)

end
