signature TRMHELPERCOMMON = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
structure Trm: TRM
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
    and Trm.TEnv = TEnv

include GLOBALS

type PreTrm 

exception UnknownId of string
val debruijnify: TEnv.T -> PreTrm -> Trm.T
val prt: TEnv.T -> Trm.T -> unit

end
