% Examples of using printers to format objects 

Printable =
  ObjectType(Rep) with
    print: String
  end;

printer  fun(p:Printable) write (Printable'print PrintableM p);

Point = 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep,
    print: String
  end;

class point : Point from thing : Thing =
  vars x:Int=0, 
       y:Int=0
  with
    setX = fun(i:Int) state@x=i,
    getX = state@x,
    print =  concat "(" 
            (concat (int_to_string state@x)
            (concat ","
            (concat (int_to_string state@y)
                    ")"
            )))
  end;

p = point'new;

CPoint = 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep,
    setC: Color->Rep, 
    getC: Color,
    print: String
  end;

class cpoint : CPoint from point : Point =
  vars c1 : Color
          = red,
       c2 : Color
          = red
  inherit setX,getX
  with
    setC = fun(c:Color) state@c1=c,
    getC = state@c1,
    print = concat (color_to_string state@c1) (super.print state)
  end;

p = cpoint'new;
Point'getX CPointM p;
